\ TickLP2553.fth - timer using the watchdog unit.

((
Copyright (c) 2007
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal


\ ==========
\ *! ticklp2553
\ *T Ticker using watchdog timer
\ ==========
\ *P The ticker interrupt is provided in *\i{TickLP2553.fth}.

[undefined] ticks [if]
variable <ticks>

: ticks		( -- n )  <ticks> @  ;
\ *G Return current clock value in milliseconds. This value
\ ** can treated as a 16 bit unsigned value that will wrap
\ ** when it overflows.
compiler
: ticks		( -- n )  <ticks> @  ;
target
[endif]

system-speed 32768 / equ TickHz	\ -- hz
\ *G Ticker speed in Herz
1000 TickHz / equ Tick-Ms	\ -- ms
\ *G Milliseconds per tick.


Proc WDT-isr
\ *G Assembler coded interrupt service routine.
\ *[
  add .w    # Tick-ms  & <ticks>
  reti
end-code
WDT-isr WDT_vec !
\ *]


: Start-Clock	\ --
\ *G Start the ticker interrupt.
  $5A10 WDTCTL !			\ interval timer, SMCLK, /32768
  $01 IFG1 bbic!			\ clear WDTIFG
  $01 IE1 bor!				\ enable WDT interrupt
  ei
;

: Stop-Clock	\ --
\ *G Stop the ticker interrupt
  $01 IE1 bbic!				\ disable WDT interrupt
;

: later         \ n -- n'
\ *G Generates the timebase value for termination in
\ ** n millseconds time.
  ticks +
;

: timedout?     \ n -- flag ; true if timed out
\ *G Flag is returned true if the timebase value n has timed out.
\ ** *\fo{TIMEDOUT?} does not call *\fo{PAUSE}.
  ticks - 0<                            \ must use circular arithmetic
;

[undefined] ms [if]
: ms            \ n --
\ *G Waits for n milliseconds.
  later
  begin
[defined] pause [if]  pause  [then]
    dup timedout?
  until
  drop
;
[then]


\ ======
\ *> ###
\ ======

decimal
