\ Duncan's simple ADC driver 16/1/14

\ ==========
\ *> drivers
\ ==========
\ *S Simple ADC driver

\ *P See the file *\i{Drivers\adc2553.fth}.
\ ** The driver is not clever. It does all the setting up for each
\ ** conversion - there is no separate set up word.
\ ** It Leaves I/O pins in analogue mode until the next conversion.
\ ** Be careful not to do a conversion on a digital pin.
\ ** The supply voltage is used as the reference.
\ ** 0 corresponds to 0V, 1023 corresponds to VCC.

$04A constant ADCAE0
\ $048 constant ADCTC0
\ $049 constant ADCTC1
\ $04B constant ADCAE1
$01B0 constant ADCCTL0
$01B2 constant ADCCTL1
$01B4 constant ADCMEM
\ : ADCSA $01BC ;

$13 equ STARTMASK

internal
: STARTADC	( --- )
	STARTMASK ADCCTL0 ! ;

: ADCDONE?	( --- f )
	ADCCTL1 @ 1 AND 0= ;

: ANALOGIN	( pin --- ; Set pin to analogue input )
	1 SWAP LSHIFT ADCAE0 C! ;

: SETCHANNEL	( pin --- ; Set ADC to convert that channel. )
	12 LSHIFT		\ Set channel
	ADCCTL1 ! ;
external

: ATOD		\ channel# -- value
\ *G DO a conversion on  the given ADC channel (0..7) and return
\ ** the value.
	DUP ANALOGIN SETCHANNEL
	STARTADC BEGIN  pause ADCDONE?  UNTIL
	ADCMEM @ ;

0 [if]
: TESTADC	( --- )
	BEGIN  4 ATOD CR 6 .R KEY? UNTIL
	KEY DROP ;
[then]


\ ======
\ *> ###
\ ======
