\ simple PWM driver - can be included from AIDE
\ Duncan Louttit 1/2/14
\ Sets up for three possible channels of
\ 10 bit PWM for 20 pin device.
\ The PWM frequency is about 7.5KHz.
\
\ Use P1.6PWM, P2.1PWM or P2.4PWM to
\ initialise the relevant port and timer.
\ P1.6 uses timer0, the other two pins use timer1.
\ Best to use P2.1 and P2.4 first to keep
\ the other timer free.
\ Once initialised, use P1.6DUTY, P2.1DUTY or
\ P2.4DUTY to set the duty cycle.
\

$0022 CONSTANT P1DIR
$0026 CONSTANT P1SEL

$002A CONSTANT P2DIR
$002E CONSTANT P2SEL

\ Timer0 PWM for P1.6

$0174 CONSTANT T0TACCR1
$0172 CONSTANT T0TACCR0
$0160 CONSTANT T0TACTL
$0164 CONSTANT T0TACCTL1

: P1.6DUTY	( value --- )
	T0TACCR1 ! ;

: P1.6PWM	( duty --- ; Start PWM on pin 1.6 )
	$3FF T0TACCR0 !
	$210 T0TACTL !
	$E0  T0TACCTL1 !
	$40 P1SEL BOR!
	$40 P1DIR BOR!
	P1.6DUTY ;

\ Timer1 pwm for P2.1 AND P2.4
$0196 CONSTANT T1TACCR2
$0194 CONSTANT T1TACCR1
$0192 CONSTANT T1TACCR0
$180 CONSTANT T1TACTL
$186 CONSTANT T1TACCTL2
$184 CONSTANT T1TACCTL1

: P2.4DUTY	( value --- )
	T1TACCR2 ! ;

: P2.1DUTY	( value --- )
	T1TACCR1 ! ;

: STARTPWM1	( --- )
	$3FF T1TACCR0 !
	$210 T1TACTL ! ;

: P2.1PWM	( duty --- ; Start PWM on pin 2.1 )
	STARTPWM1
	$E0 T1TACCTL1 !
	P2SEL C@ 2 OR P2SEL C!
	P2DIR C@ 2 OR P2DIR C!
	P2.1DUTY ;

: P2.4PWM	( duty --- ; Start PWM on pin 2.4 )
	STARTPWM1
	$E0 T1TACCTL2 !
	P2SEL C@ $10 OR P2SEL C!
	P2DIR C@ $10 OR P2DIR C!
	P2.4DUTY ;


