\ DELAYS.FTH - waiting around

((
Copyright (c) 2005, 2013
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20131220 SFP001 MSP430 Lite conversion.
))

decimal


\ =========
\ *! delays
\ *T Time Delays
\ =========
\ *P The code in *\i{Delays.fth} allows you to handle time
\ ** delays specified in milliseconds.

[undefined] ticks [if]
variable <ticks>

: ticks		( -- n )  <ticks> @  ;
\ *G Return current clock value in milliseconds. This value
\ ** can treated as a 16 bit unsigned value that wraps
\ ** when it overflows.
compiler
: ticks		( -- n )  <ticks> @  ;
target
[endif]


: later         \ n -- n'
\ *G Generates the timebase value for termination in
\ ** n millseconds time.
  ticks +
;

: timedout?     \ n -- flag ; true if timed out
\ *G Flag is returned true if the timebase value n has timed out.
\ ** *\fo{TIMEDOUT?} does not call *\fo{PAUSE}.
  ticks - 0<                            \ must use circular arithmetic
;

optimised? [if]
compiler
: later         \ n -- n'
  ticks +
;

: timedout?     \ n -- flag ; true if timed out
  ticks - 0<                            \ must use circular arithmetic
;
target
[then]

[undefined] ms [if]
: ms            \ n --
\ *G Waits for n milliseconds.
  later
  begin
    pause dup timedout?
  until
  drop
;
[then]


\ ======
\ *> ###
\ ======

decimal
