\ LIB430.FTH - MSP430 CPU specific library file

((
Copyright (c) 2003
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal

\ =========
\ *! lib430
\ *T MSP430 library
\ =========
\ *P The library file LIB430.FTH can be used between
\ ** LIBRARIES and END-LIBS to resolve outstanding forward
\ ** references. See the Forth 6 manual for more details of
\ ** the library mechanism.
\ *E libraries	\ resolve required forward references
\ **   include %CpuDir%\lib430
\ ** \  include %CommonDir%\library \ for standalone apps
\ **   include %CommonDir%\uflib    \ for Umbilical apps
\ ** end-libs


[required] save-int [if]
code save-int   \ -- n ; save interrupt status
\ *G Geturn interrupt status and then disable interrupts.
\ ** Use [I and I] for new code.
  sub    # 2  psp
  mov    tos  0 (psp)
  mov    sr  tos
  dint
  ret
end-code
[then]

[required] restore-int [if]
code restore-int        \ n -- ; restore interrupt
\ *G Restore state returned by SAVE-INT.
\ ** Use [I and I] for new code.
  mov    tos  sr
  mov    @psp+  tos
  ret
end-code
[then]

[required] init-iow [if]
: init-iow	\ addr --
\ *G Copy the contents of the I/O set up table to an I/O device.
\ ** The data is written as 16 bit words. See also INIT-IOB.
\ ** Each element of the table is of the form addr (cell) followed
\ ** by data (cell). The table is terminated by an address of 0.
\ ** A table of a single 0 address performs no action.
  begin
    dup @
   while
    dup 2@ !  2 cells +
  repeat
  drop
;
[then]

[required] init-iob [if]
: init-iob	\ addr --
\ *G Copy the contents of the I/O set up table to an I/O device.
\ ** The data is written as 8 bit bytes. See also INIT-IOW.
\ ** Each element of the table is of the form addr (cell) followed
\ ** by data (cell). The table is terminated by an address of 0.
\ ** A table of a single 0 address performs no action.
  begin
    dup @
   while
    dup 2@ c!  2 cells +
  repeat
  drop
;
[then]


\ ======
\ *> ###
\ ======
