\ MSP430x2xx Special function registers and equates

((
Copyright (c) 2012
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20120823 MPE001 First cut
))


\ **********
\ Interrupts
\ **********
\ Interrupt vectors for this family of MSP430s are defined in
\ separate vecxxxx.fth files.


\ *******************
\ Basic Clock Module+
\ *******************

$056 equ DCOCTL
$057 equ BCSCTL1
$058 equ BCSCTL2
$053 equ BCSCTL3


\ **************
\ DMA Controller
\ **************

$0122 equ DMACTL0
$0124 equ DMACTL1
$0126 equ DMAIV

$01D0 equ DMA0CTL
$01D2 equ DMA0SA
$01D6 equ DMA0DA
$01DA equ DMA0SZ

$01DC equ DMA1CTL
$01DE equ DMA1SA
$01E2 equ DMA1DA
$01E6 equ DMA1SZ

$01E8 equ DMA2CTL
$01EA equ DMA2SA
$01EE equ DMA2DA
$01F2 equ DMA2SZ


\ ***********************
\ Flash memory controller
\ ***********************

$0128 equ FCTL1
$012A equ FCTL2
$012C equ FCTL3
$01BE equ FCTL4


\ *********************
\ Digital I/O registers
\ *********************

(( defined in SFR430.FTH
#define P1IN  0x0020
#define P1OUT 0x0021
#define P1DIR 0x0022
#define P1IFG 0x0023
#define P1IES 0x0024
#define P1IE  0x0025
#define P1SEL 0x0026
))
$041 equ P1SEL2
$027 equ P1REN

((
#define P2IN  0x0028
#define P2OUT 0x0029
#define P2DIR 0x002A
#define P2IFG 0x002B
#define P2IES 0x002C
#define P2IE  0x002D
#define P2SEL 0x002E
))
$042 equ P2SEL2
$02F equ P2REN

#define P3IN  0x0018
#define P3OUT 0x0019
#define P3DIR 0x001A
#define P3SEL 0x001B
$043 equ P3SEL2
$010 equ P3REN

#define P4IN  0x001C
#define P4OUT 0x001D
#define P4DIR 0x001E
#define P4SEL 0x001F
$044 equ P4SEL2
$011 equ P4REN

#define P5IN  0x0030
#define P5OUT 0x0031
#define P5DIR 0x0032
#define P5SEL 0x0033
$045 equ P5SEL2
$012 equ P5REN

#define P6IN  0x0034
#define P6OUT 0x0035
#define P6DIR 0x0036
#define P6SEL 0x0037
$046 equ P6SEL2
$013 equ P6REN

#define P7IN  0x0038
#define P7OUT 0x003A
#define P7DIR 0x003C
#define P7SEL 0x003E
$047 equ P7SEL2
$014 equ P7REN

#define P8IN  0x0039
#define P8OUT 0x003B
#define P8DIR 0x003D
#define P8SEL 0x003F
$048 equ P8SEL2
$015 equ P8REN


\ *************************
\ Supply Voltage Supervisor - SVS
\ *************************

$055 equ SVSCTL

\ *****
\ WDCTL in sfr430.fth
\ *****

\ ***
\ MPY in sfr430.fth
\ ***

\ *******
\ Timer_A register frame
\ *******

#define TACTL    0x0160
#define TAR      0x0170
#define CCTL0    0x0162
#define TACCR0   0x0172
#define TACCTL1  0x0164
#define TACCR1   0x0174
#define TACCTL2  0x0166
#define TACCR2   0x0176
#define TAIV     0x012E


\ *******
\ Timer_B register frame
\ *******

#define TBCTL   0x0180
#define TBR     0x0190

#define TBCCTL0 0x0182
#define TBCCR0  0x0192
#define TBCCTL1 0x0184
#define TBCCR1  0x0194
#define TBCCTL2 0x0186
#define TBCCR2  0x0196
#define TBCCTL3 0x0188
#define TBCCR3  0x0198
#define TBCCTL4 0x018A
#define TBCCR4  0x019A
#define TBCCTL5 0x018C
#define TBCCR5  0x019C
#define TBCCTL6 0x018E
#define TBCCR6  0x019E
#define TBIV    0x011E


\ ***
\ USI - SPI and I2C
\ ***

$078 equ USICTL
  $078 equ USICTL0
  $079 equ USICTL1
$07A equ USICKCTL
$07B equ USICNT
$07C equ USISR
  $07C equ USISRL
  $07D equ USISRH


\ ****
\ USCI - UART, SPI and I2C
\ ****

$060 equ UCA0CTL0
$061 equ UCA0CTL1
$062 equ UCA0BR0
$063 equ UCA0BR1
$064 equ UCA0MCTL
$065 equ UCA0STAT
$066 equ UCA0RXBUF
$067 equ UCA0TXBUF

$05D equ UCA0ABCTL
$05E equ UCA0IRTCTL
$05F equ UCA0IRRCTL

$068 equ UCB0CTL0
$069 equ UCB0CTL1
$06A equ UCB0BR0
$06B equ UCB0BR1
$06C equ UCB0MCTL
$06D equ UCB0STAT
$06E equ UCB0RXBUF
$06F equ UCB0TXBUF

$0118 equ UCB0I2COA
$0119 equ UCB0I2CSA

$0D0 equ UCA1CTL0
$0D1 equ UCA1CTL1
$0D2 equ UCA1BR0
$0D3 equ UCA1BR1
$0D4 equ UCA1MCTL
$0D5 equ UCA1STAT
$0D6 equ UCA1RXBUF
$0D7 equ UCA1TXBUF

$0CD equ UCA1ABCTL
$0CE equ UCA1IRTCTL
$0CF equ UCA1IRRCTL

$0D8 equ UCB1CTL0
$0D9 equ UCB1CTL1
$0DA equ UCB1BR0
$0DB equ UCB1BR1
$0DC equ UCB1MCTL
$0DD equ UCB1STAT
$0DE equ UCB1RXBUF
$0DF equ UCB1TXBUF

$017C equ UCB1I2COA
$017E equ UCB1I2CSA

$006 equ UC1IE
$007 equ UC1IFG


\ *****
\ USART - USART and SPI
\ *****

$070 equ U0CTL
$071 equ U0TCTL
$072 equ U0RCTL
$073 equ U0MCTL
$074 equ U0BR0
$075 equ U0BR1
$076 equ U0RXBUF
$077 equ U0TXBUF

$078 equ U1CTL
$079 equ U1TCTL
$07A equ U1RCTL
$07B equ U1MCTL
$07C equ U1BR0
$07D equ U1BR1
$07E equ U1RXBUF
$07F equ U1TXBUF


\ **
\ OA - Operational Amplifier
\ **

$0C0 equ OA0CTL0
$0C1 equ OA0CTL1
$0C2 equ OA1CTL0
$0C3 equ OA1CTL1
$0C4 equ OA2CTL0
$0C5 equ OA2CTL1


\ *************
\ Comparator A+
\ *************

#define CACTL1 0x0059
#define CACTL2 0x005A
#define CAPD   0x005B


\ *****
\ ADC10
\ *****

$04A equ ADC10AE0
$04B equ ADC10AE1
$01B0 equ ADC10CTL0
$01B2 equ ADC10CTL1
$01B4 equ ADC10MEM
$048 equ ADC10TC0
$049 equ ADC10TC1
$01BC equ ADC10SA


\ *****
\ ADC12
\ *****

#define ADC12CTL0   0x01A0
#define ADC12CTL1   0x01A2
#define ADC12IFG    0x01A4
#define ADC12IE     0x01A6
#define ADC12IV     0x01A8

#define ADC12MEM0   0x0140
#define ADC12MEM1   0x0142
#define ADC12MEM2   0x0144
#define ADC12MEM3   0x0146
#define ADC12MEM4   0x0148
#define ADC12MEM5   0x014A
#define ADC12MEM6   0x014C
#define ADC12MEM7   0x014E
#define ADC12MEM8   0x0150
#define ADC12MEM9   0x0152
#define ADC12MEM10  0x0154
#define ADC12MEM11  0x0156
#define ADC12MEM12  0x0158
#define ADC12MEM13  0x015A
#define ADC12MEM14  0x015C
#define ADC12MEM15  0x015E

#define ADC12MCTL0  0x0080
#define ADC12MCTL1  0x0081
#define ADC12MCTL2  0x0082
#define ADC12MCTL3  0x0083
#define ADC12MCTL4  0x0084
#define ADC12MCTL5  0x0085
#define ADC12MCTL6  0x0086
#define ADC12MCTL7  0x0087
#define ADC12MCTL8  0x0088
#define ADC12MCTL9  0x0089
#define ADC12MCTL10 0x008A
#define ADC12MCTL11 0x008B
#define ADC12MCTL12 0x008C
#define ADC12MCTL13 0x008D
#define ADC12MCTL14 0x008E
#define ADC12MCTL15 0x008F


\ *****
\ DAC12
\ *****

$01C0 equ DAC12_0CTL
$01C8 equ DAC12_0DAT
$01C2 equ DAC12_1CTL
$01CA equ DAC12_1DAT


\ ******
\ SD16_A Sigma Delta
\ ******

$0100 equ SD16CTL
$0110 equ SD16IV
$0102 equ SD16CTL0
$0112 equ SD16MEM0
$00B0 equ SD16INCTL0
$00B7 equ SD16AE


\ ******
\ SD24_A Sigma Delta
\ ******

$0100 equ SD24CTL
$0110 equ SD24IV
$00B7 equ SD24AE

$0102 equ SD24CTL0
$0112 equ SD24MEM0
$00B0 equ SD24INCTL0
$00B8 equ SD24PRE0

$0104 equ SD24CCTL1
$0114 equ SD24MEM1
$00B1 equ SD24INCTL1
$00B9 equ SD24PRE1

$0106 equ SD24CCTL2
$0116 equ SD24MEM2
$00B2 equ SD24INCTL2
$00BA equ SD24PRE2

$0108 equ SD24CCTL3
$0118 equ SD24MEM3
$00B3 equ SD24INCTL3
$00BB equ SD24PRE3

$010A equ SD24CCTL4
$011A equ SD24MEM4
$00B4 equ SD24INCTL4
$00BC equ SD24PRE4

$010C equ SD24CCTL5
$011C equ SD24MEM5
$00B5 equ SD24INCTL5
$00BD equ SD24PRE5

$010E equ SD24CCTL6
$011E equ SD24MEM6
$00B6 equ SD24INCTL6
$00BE equ SD24PRE6

