\ Value.fth - Operator methods used by VALUE

((
Released for use with the MPE Forth Cross Compiler by:

Copyright (c) 1998-1999, 2012
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))


\ ========
\ *! value
\ *T Target VALUE
\ =======
\ *P The file *\i{value.fth} implements the compilation
\ ** of *\fo{VALUE}s on the target.

internal
variable OPERATORTYPE		\ used at compile time for prefix operator
external

interpreter
: OPERATOR      \ n -- ; define an operator in the cross compiler
\ *G An interpreter definition that build new operators such as "to" and "addr".
  create immediate
    ,
  does>
    @ operatortype !
;
target

decimal

 0     equ DEFAULTOP
 1 dup equ STOREOP operator to                 \ store operator
 1                 operator ->                 \   "
 2 dup equ ADDROP operator ADDR                \ address operator

internal
: BAD-METHOD    \ -- ;
  #-13 throw
;
external

internal
: VAL-COMPILE/EXECUTE   \ value xt[c] xt[e] --
  state @ if
    drop  compile, ,
  else
    nip  execute
  endif
;
external

: VALUE         \ n -- ; --  n ; n VALUE <name>
\ *G Creates a variable of initial value n that returns its contents
\ ** when referenced. To store to a child of VALUE use "n to <child>".
  rhere constant
    immediate  rhere !  2 rallot
  does>
    case  operatortype @  operatortype off
      defaultop of  ['] val@  ['] @     val-compile/execute  endof
      storeop   of  ['] val!  ['] !     val-compile/execute  endof
      addrop    of  state @ if  c_lit  endif                 endof
                      bad-method
    endcase
;


\ ======
\ *> ###
\ ======

